import java.awt.*;
public class DrawingRoadTrain {
    private EntityRoadTrain entityRoadTrain;
    private DrawingWheels drawingWheels;
    private int _pictureWidth;
    private int _pictureHeight;
    private int _startPosX;
    private int _startPosY;
    private final int _trainWidth = 90;
    private final int _trainHeight = 70;
    public boolean Init(int speed, double weight, Color bodyColor, Color additionalColor, boolean waterContainer, boolean sweepingBrush, int width, int height, int wheelnumber){
        if (width < _trainWidth || height <_trainHeight){
            return false;
        }
        _pictureWidth = width;
        _pictureHeight = height;
        entityRoadTrain = new EntityRoadTrain();
        entityRoadTrain.Init(speed, weight, bodyColor, additionalColor, waterContainer, sweepingBrush);
        drawingWheels = new DrawingWheels();
        drawingWheels.SetWheelNumber(wheelnumber);
        return true;
    }
    public void SetPosition(int x, int y){
        if (x < 0 || x + _trainWidth > _pictureWidth){
            x = 200;
        }
        if (y < 0 || y + _trainHeight > _pictureHeight){
            y = 200;
        }
        _startPosX = x;
        _startPosY = y;
    }
    public void MoveTransport(DirectionType direction){
        if (entityRoadTrain == null){
            return;
        }
        switch (direction){
            case Left:
                if (_startPosX - entityRoadTrain.GetStep() > 0){
                    _startPosX -= (int)entityRoadTrain.GetStep();
                }
                break;
            case Up:
                if (_startPosY - entityRoadTrain.GetStep() > 0){
                    _startPosY -= (int)entityRoadTrain.GetStep();
                }
                break;
            case Right:
                if (_startPosX + entityRoadTrain.GetStep() + _trainWidth < _pictureWidth){
                    _startPosX += (int)entityRoadTrain.GetStep();
                }
                break;
            case Down:
                if (_startPosY + entityRoadTrain.GetStep() + _trainHeight < _pictureHeight){
                    _startPosY += (int)entityRoadTrain.GetStep();
                }
                break;
        }
    }
    public void DrawTransport(Graphics g){
        if (entityRoadTrain == null){
            return;
        }
        if (entityRoadTrain.GetWaterContainer()){
            g.setColor(entityRoadTrain.GetAdditionalColor());
            g.drawOval(_startPosX + 30, _startPosY, 10, 20);
            g.fillOval(_startPosX + 30, _startPosY, 10, 20);
        }
        if (entityRoadTrain.GetSweepingBrush())
        {
            g.drawLine(_startPosX + 30, _startPosY + 10, _startPosX + 20, _startPosY + 10);
            g.drawLine(_startPosX + 20, _startPosY + 10, _startPosX + 10, _startPosY + 30);
            g.drawLine(_startPosX + 17, _startPosY + 30, _startPosX + 3, _startPosY + 30);
        }
        drawingWheels.drawWheels(g,entityRoadTrain.GetBodyColor(), _startPosX, _startPosY);
        g.setColor(entityRoadTrain.GetBodyColor());
        g.drawLine(_startPosX + 20, _startPosY + 20, _startPosX + 70, _startPosY + 20);

        g.drawRect( _startPosX + 60, _startPosY, 10, 20);

        g.fillRect(_startPosX + 60, _startPosY, 10, 20);
    }
}
