import javax.swing.*;
import java.awt.*;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.*;

public class RoadTrainForm{
    private DrawingRoadTrain _drawingRoadTrain;
    Canvas canv;
    public void Draw(){
        canv.repaint();
    }
    public RoadTrainForm(){
        JFrame frame = new JFrame("RoadTrain");
        JButton buttonCreate = new JButton("Создать");
        buttonCreate.setFocusPainted(false);
        buttonCreate.setContentAreaFilled(false);
        JButton buttonUp = new JButton();
        buttonUp.setFocusPainted(false);
        buttonUp.setContentAreaFilled(false);
        buttonUp.setName("up");
        buttonUp.setIcon(new ImageIcon(((new ImageIcon("Resources/ArrowUp.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        JButton buttonDown = new JButton();
        buttonDown.setFocusPainted(false);
        buttonDown.setContentAreaFilled(false);
        buttonDown.setName("down");
        buttonDown.setIcon(new ImageIcon(((new ImageIcon("Resources/ArrowDown.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        JButton buttonLeft = new JButton();
        buttonLeft.setFocusPainted(false);
        buttonLeft.setContentAreaFilled(false);
        buttonLeft.setName("left");
        buttonLeft.setIcon(new ImageIcon(((new ImageIcon("Resources/ArrowLeft.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        JButton buttonRight = new JButton();
        buttonRight.setFocusPainted(false);
        buttonRight.setContentAreaFilled(false);
        buttonRight.setName("right");
        buttonRight.setIcon(new ImageIcon(((new ImageIcon("Resources/ArrowRight.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        buttonCreate.addActionListener(
                e -> {
                    System.out.println(e.getActionCommand());
                    Random random = new Random();
                    _drawingRoadTrain = new DrawingRoadTrain();
                    _drawingRoadTrain.Init(
                            random.nextInt(200) + 100,
                            random.nextInt(2000) + 1000,
                            new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                            new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                            random.nextBoolean(), random.nextBoolean(), this.canv.getWidth(), this.canv.getHeight(), random.nextInt(3));
                    _drawingRoadTrain.SetPosition(random.nextInt(100), random.nextInt(90));
                    canv._drawingRoadTrain = _drawingRoadTrain;
                    Draw();
                }
        );
        ActionListener actionListener = e -> {
            System.out.println(((JButton)(e.getSource())).getName());
            if (_drawingRoadTrain == null){
                return;
            }
            switch ((((JButton)(e.getSource())).getName())){
                case "up":
                    _drawingRoadTrain.MoveTransport(DirectionType.Up);
                    break;
                case "down":
                    _drawingRoadTrain.MoveTransport(DirectionType.Down);
                    break;
                case "left":
                    _drawingRoadTrain.MoveTransport(DirectionType.Left);
                    break;
                case "right":
                    _drawingRoadTrain.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();
        };
        buttonUp.addActionListener(actionListener);
        buttonDown.addActionListener(actionListener);
        buttonLeft.addActionListener(actionListener);
        buttonRight.addActionListener(actionListener);
        frame.setSize(900, 500);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setLayout(null);
        canv = new Canvas();
        canv.setBounds(0, 0, 900, 500);
        buttonCreate.setBounds(20, 420, 100, 40);
        buttonUp.setBounds(800, 380, 40, 40);
        buttonDown.setBounds(800, 420, 40, 40);
        buttonLeft.setBounds(760, 420, 40, 40);
        buttonRight.setBounds(840, 420, 40, 40);
        frame.add(canv);
        frame.add(buttonCreate);
        frame.add(buttonUp);
        frame.add(buttonDown);
        frame.add(buttonLeft);
        frame.add(buttonRight);
        frame.setVisible(true);
    }
    class Canvas extends JComponent{
        public DrawingRoadTrain _drawingRoadTrain;
        public Canvas(){}

        public void paintComponent(Graphics g){
            if (_drawingRoadTrain == null){
                return;
            }
            super.paintComponents(g);
            Graphics2D g2d = (Graphics2D)g;
            _drawingRoadTrain.DrawTransport(g2d);
            super.repaint();
        }
    }
}